//#################################################################################################//
//#                                                                                               #// 
//#  **** Schneider Engineering, Bad Vilbel ***                                                   #//
//#  **** Inh.  Dipl.-Ing. Peter Schneider  ***                                                   #//
//#                                                                                               #//
//#  Filename : help_routines.h                                                                   #//
//#  Project  : Odemetrie                                                                         #//
//#  Darstellen des Algorithmus in einer DAS-BOX                                                  #//
//#                                                                                               #//
//#                                                                                               #//
//#                                                                                               #//    
//#  Odemetrie mit bug2 Pathfindig Algorithmus ein moeglicher Implementierungsvorschlag           #// 
//#  Quelle des Algorithmus www.wikipedia.de                                                      #//
//#                                                                                               #//
//#  (c) Peter Schneider (Schneider Engineering software / hardware development)                  #//
//#  www.ps-robotics.com                                                                          #//
//#                                                                                               #//
//#  Version:                                                                                     #//         
//#  1.03       14 August 2011 11:55       Original release                                       #//
//#                                                                                               #//
//# This program is free software; you can redistribute it and/or modify                          #//
//# it under the terms of the GNU General Public License as published by                          #//
//# the Free Software Foundation; either version 2 of the License, or                             #//
//# (at your option) any later version.                                                           #//
//#                                                                                               #//		
//# This program is distributed in the hope that it will be useful,                               #//
//# but WITHOUT ANY WARRANTY; without even the implied warranty of                                #//	
//# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                 #//	
//# GNU General Public License for more details.                                                  #//
//#                                                                                               #//
//# You should have received a copy of the GNU General Public License                             #//
//# along with this program; if not, write to peter.schneider@ps-robotics.de                      #//
//#                                                                                               #//
//#################################################################################################//
//
//  Hilfsdateien die eine Darstellung des Algorithmus in einer DOS-Box ermglichen
//




// -----------------------------------------------------------------------------------------------
// *************  hindernis und RAHMEN zeichnen ************* 
// *****
void init_hindernis (void)
{ 
   int i;
   int j;

   for  (i = 0; i <= xh; i++)                       // Init Matrix  alle Werte auf "0"
   {
      for  (j = 0; j <= yh; j++)
         matrix [i][j] = 0;
   }   

   clrscr ();                                       // Clear Screen
   

   matrix [8][6]   = 1;
   matrix [8][7]   = 1;                             // durch die Matrix Init Funktion sind alle
   matrix [8][8]   = 1;                             // anderen werte  "0" 
   matrix [8][9]   = 1;                             // durch die Matrix Init Funktion sind alle
   matrix [8][10]  = 1;           
   matrix [8][11]  = 1;
   matrix [8][12]  = 1;
   matrix [8][13]  = 1;
   gotoxy (8+1,6+1);         
   printf ("#"); 
   gotoxy (8+1,7+1);         
   printf ("#");                  
   gotoxy (8+1,8+1);                 
   printf ("#");                 
   gotoxy (8+1,9+1);         
   printf ("#");  
   gotoxy (8+1,10+1);         
   printf ("#");
   gotoxy (8+1,11+1);         
   printf ("#");
   gotoxy (8+1,12+1);         
   printf ("#");
   gotoxy (8+1,13+1);       
   printf ("#");
   
   

   matrix [20][4]  = 1;
   matrix [20][5]  = 1;
   matrix [20][6]  = 1;
   matrix [20][7]  = 1;
   matrix [20][8]  = 1;
   matrix [20][9]  = 1;
   matrix [20][10]  = 1;
   matrix [20][11]  = 1;
   matrix [20][12]  = 1;
   matrix [20][13]  = 1;
      matrix [19][13]  = 1;
      matrix [18][13]  = 1;
      matrix [17][13]  = 1;
      matrix [16][13]  = 1;
      matrix [15][13]  = 1;
      matrix [14][13]  = 1;
   matrix [19][4]  = 1;
   matrix [18][4]  = 1;
   matrix [17][4]  = 1;   
      matrix [13][12]  = 1;
      matrix [12][11]  = 1;          
      matrix [13][10]  = 1;   
   matrix [14][9]  = 1;
   matrix [15][9]  = 1;
   matrix [16][9]  = 1;       

    
      
        
      
      
   gotoxy (20+1,4+1);         
   printf ("#");
   gotoxy (20+1,5+1);       
   printf ("#");
   gotoxy (20+1,6+1);         
   printf ("#");
   gotoxy (20+1,7+1);       
   printf ("#");
   gotoxy (20+1,8+1);       
   printf ("#");
   gotoxy (20+1,9+1);         
   printf ("#");
   gotoxy (20+1,10+1);       
   printf ("#");   
   gotoxy (20+1,11+1);         
   printf ("#");
   gotoxy (20+1,12+1);       
   printf ("#");
   gotoxy (20+1,13+1);         
   printf ("#");
     gotoxy (19+1,13+1);         
     printf ("#");
     gotoxy (18+1,13+1);         
     printf ("#");
     gotoxy (17+1,13+1);         
     printf ("#");
     gotoxy (16+1,13+1);         
     printf ("#");
     gotoxy (15+1,13+1);         
     printf ("#");
     gotoxy (14+1,13+1);         
     printf ("#");   
   gotoxy (19+1,4+1);         
   printf ("#");
   gotoxy (18+1,4+1);         
   printf ("#");
   gotoxy (17+1,4+1);         
   printf ("#");
      gotoxy (13+1,12+1);         
      printf ("#");
      gotoxy (12+1,11+1);       
      printf ("#");
      gotoxy (13+1,10+1);         
      printf ("#");
   gotoxy (14+1,9+1);         
   printf ("#");
   gotoxy (15+1,9+1);         
   printf ("#");
   gotoxy (16+1,9+1);         
   printf ("#");
   


   
         
      
   // Begrenzung setzen
   for (i=0; i <xh+1 ;i++)
   {
      matrix [i][0]     = 1; 
      matrix [i][yh+1]  = 1;
   }
      
   for (i=0; i <yh+1; i++)
   {
      matrix [0][i]     = 1; 
      matrix [xh+1][i]  = 1;
   } 


   // -----------------------------------------------------
   for  (i=xl;i<=(xh+1);i++)             // Rahmen zeichnen  
   {
      gotoxy (i,(yl-1));
      printf ("-");
      gotoxy (i,(yh+2));
      printf ("-");
   }
   for  (i=yl;i<=(yh+1);i++)
   {
      gotoxy ((xl-1),i);
      printf ("|");
      gotoxy ((xh+2),i);
      printf ("|");
   }

   gotoxy (Start_X+1, Start_Y+1);                      // Start und Ziel einzeichnen
   printf ("S");
        
   gotoxy (Ziel_X+1, Ziel_Y+1);
   printf ("Z");  
   
   
   gotoxy (46, 5);
   printf ("BUG 2 Pathfinding Algorithmus.  ENTER druecken bis Hindernis erreicht wird");
   gotoxy (46, 6);
   printf ("Hindernis immer rechts herum umfahren");
   
   gotoxy (46, 10);
   printf ("Sensor_Links  = ");
   gotoxy (46, 11);
   printf ("Sensor_Mitte  = ");
   gotoxy (46, 12);
   printf ("Sensor_Rechts = ");
   
   gotoxy (46, 14);
   printf ("Move_Direction= ");
   gotoxy (46, 15);
   printf ("Last move_dir = ");

}  // Ende Funktion init_hindernis
// ------------------------------------------------------------------------------------------------------










// ************ Rahmen zeichnen ************* 
// *****
void  rahmenzeichnen (int rxl, int ryl, int rxh, int ryh)
{
   int i;
   for  (i=rxl;i<=(rxh+1);i++)
   {
      gotoxy (i,(ryl-1));
      printf ("-");
      gotoxy (i,(ryh+2));
      printf ("-");
   }
   for  (i=ryl;i<=(ryh+1);i++)
   {
      gotoxy ((rxl-1),i);
      printf ("|");
      gotoxy ((rxh+2),i);
      printf ("|");
   }
}






// *************  Cursor zeichnen ************* 
// *****
void Coursor_Zeichnen (int Xn, int Yn)
{
   
   gotoxy (X_coursor_alt+1,Y_coursor_alt+1);
   printf (" ");    
      
   gotoxy (Xn+1, Yn+1);         
   printf ("X");
    
   X_coursor_alt = Xn;  
   Y_coursor_alt = Yn; 
   
   gotoxy (46,2);
   printf ("                ");
   gotoxy (46,2);
   printf ("Coursor = %d  %d", Xn, Yn); 
   
   
   
  
   // --------------------------------------------
   if (sensor_links == TRUE)
   { 
      gotoxy (62, 10);
      printf ("TRUE ");
   }
   else 
   {
      gotoxy (62, 10);
      printf ("FALSE");
   }
   if (sensor_mitte == TRUE)
   { 
      gotoxy (62, 11);
      printf ("TRUE ");
   }
   else 
   {
      gotoxy (62, 11);
      printf ("FALSE");
   }   
   if (sensor_rechts == TRUE)
   { 
      gotoxy (62, 12);
      printf ("TRUE ");
   }
   else 
   {
      gotoxy (62, 12);
      printf ("FALSE");
   }     
   
   

 
   
   // -------------------------------------------------
   if (move_dir == 3)
   { 
      gotoxy (62, 14);
      printf ("FWD  ");
   }
   else if (move_dir == 4)
   {
      gotoxy (62, 14);
      printf ("BWD  ");
   }   
   else if (move_dir == 1)
   {
      gotoxy (62, 14);
      printf ("LEFT ");
   }     
    else if (move_dir == 2)
   {
      gotoxy (62, 14);
      printf ("RIGHT");
   }     
   
   
   if (last_dir == 3)
   { 
      gotoxy (62, 15);
      printf ("FWD  ");
   }
   else if (last_dir == 4)
   {
      gotoxy (62, 15);
      printf ("BWD  ");
   }   
   else if (last_dir == 1)
   {
      gotoxy (62, 15);
      printf ("LEFT ");
   }     
    else if (last_dir == 2)
   {
      gotoxy (62, 15);
      printf ("RIGHT");
   }     
   
   
   
   // -----------------------------------------------------------
   gotoxy (46, 17);  
   printf ("                   "); 
   gotoxy (46, 17);
   printf ("DB-Query = %d", db_query);
   
}



 







// *********** Anzeigen der Umgebungs-Matrix ************** 
// *****
void matrix_anzeigen(void)
{
   int i;
   int j;
   
   for (i=0; i<=xh+1; i++)
   { 
      for (j=0; j <= yh+1; j++)
      {
    	gotoxy ((18 + i*2) , (2 + j));       
	printf ("%d", matrix [i][j]);
      }
   }    
}










// ************ Initialisiere Ungebungs-Matrix ************* 
// *****
void  init_matrix (void)
{
   int i;
   int j;
   for  (i = 0; i <= xh; i++)
   {
      for  (j = 0; j <= yh; j++)
         matrix [i][j] = 0;
   }      
}










// ************ Startbildschirm zeichnen ************* 
// *****
void  init_bildschirm (void)
{
   /* *************** Aufbau Startbildschirm ************** */
        
   clrscr ();
   rahmenzeichnen (xl,yl,xh,yh); 
    
   gotoxy (Start_X+1, Start_Y+1);
   printf ("S");
        
   gotoxy (Ziel_X+1, Ziel_Y+1);
   printf ("Z");    
}




    












